#include "CenteredTextDrawerGL.hxx"
/* Generated by GIWS (version 1.0.5) */
/*

Copyright 2007-2008 INRIA

Author : Sylvestre Ledru & others

This software is a computer program whose purpose is to hide the complexity
of accessing Java objects/methods from C++ code.

This software is governed by the CeCILL-B license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL-B
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL-B license and that you accept its terms.
*/

namespace org_scilab_modules_renderer_textDrawing {

// Returns the current env

JNIEnv * CenteredTextDrawerGL::getCurrentEnv() {
JNIEnv * curEnv = NULL;
this->jvm->AttachCurrentThread(reinterpret_cast<void **>(&curEnv), NULL);
return curEnv;
}
// Destructor

CenteredTextDrawerGL::~CenteredTextDrawerGL() {
JNIEnv * curEnv = NULL;
this->jvm->AttachCurrentThread(reinterpret_cast<void **>(&curEnv), NULL);

curEnv->DeleteGlobalRef(this->instance);
curEnv->DeleteGlobalRef(this->instanceClass);
curEnv->DeleteGlobalRef(this->stringArrayClass);}
// Constructors

CenteredTextDrawerGL::CenteredTextDrawerGL(JavaVM * jvm_) {
jmethodID constructObject = NULL ;
jobject localInstance ;
jclass localClass ;
const std::string construct="<init>";
const std::string param="()V";
jvm=jvm_;

JNIEnv * curEnv = getCurrentEnv();

localClass = curEnv->FindClass( this->className().c_str() ) ;
if (localClass == NULL) {
  throw GiwsException::JniClassNotFoundException(curEnv, this->className());
}

this->instanceClass = static_cast<jclass>(curEnv->NewGlobalRef(localClass));

/* localClass is not needed anymore */
curEnv->DeleteLocalRef(localClass);

if (this->instanceClass == NULL) {
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}


constructObject = curEnv->GetMethodID( this->instanceClass, construct.c_str() , param.c_str() ) ;
if(constructObject == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}

localInstance = curEnv->NewObject( this->instanceClass, constructObject ) ;
if(localInstance == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}
 
this->instance = curEnv->NewGlobalRef(localInstance) ;
if(this->instance == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}
/* localInstance not needed anymore */
curEnv->DeleteLocalRef(localInstance);

                /* Methods ID set to NULL */
voiddisplayID=NULL; 
voidinitializeDrawingjintID=NULL; 
voidendDrawingID=NULL; 
voidshowjintID=NULL; 
voiddestroyjintID=NULL; 
voidsetTextParametersjintjintjintjdoublejdoublejbooleanID=NULL; 
voidsetBoxDrawingParametersjbooleanjbooleanjintjintID=NULL; 
voidsetTextContentjobjectArrayjintjintID=NULL; 

jclass localStringArrayClass = curEnv->FindClass("java/lang/String");
stringArrayClass = static_cast<jclass>(curEnv->NewGlobalRef(localStringArrayClass));
curEnv->DeleteLocalRef(localStringArrayClass);
voidsetCenterPositionjdoublejdoublejdoubleID=NULL; 
jdoubleArraydrawTextContentID=NULL; 
voidsetFilledBoxSizejdoublejdoubleID=NULL; 
jdoubleArraygetScreenBoundingBoxjdoublejdoublejdoubleID=NULL; 
jdoubleArrayupdateParentFigurejintID=NULL; 


}

CenteredTextDrawerGL::CenteredTextDrawerGL(JavaVM * jvm_, jobject JObj) {
        jvm=jvm_;

        JNIEnv * curEnv = getCurrentEnv();

jclass localClass = curEnv->GetObjectClass(JObj);
        this->instanceClass = static_cast<jclass>(curEnv->NewGlobalRef(localClass));
        curEnv->DeleteLocalRef(localClass);

        if (this->instanceClass == NULL) {
throw GiwsException::JniObjectCreationException(curEnv, this->className());
        }

        this->instance = curEnv->NewGlobalRef(JObj) ;
        if(this->instance == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
        }
        /* Methods ID set to NULL */
        voiddisplayID=NULL; 
voidinitializeDrawingjintID=NULL; 
voidendDrawingID=NULL; 
voidshowjintID=NULL; 
voiddestroyjintID=NULL; 
voidsetTextParametersjintjintjintjdoublejdoublejbooleanID=NULL; 
voidsetBoxDrawingParametersjbooleanjbooleanjintjintID=NULL; 
voidsetTextContentjobjectArrayjintjintID=NULL; 

jclass localStringArrayClass = curEnv->FindClass("java/lang/String");
stringArrayClass = static_cast<jclass>(curEnv->NewGlobalRef(localStringArrayClass));
curEnv->DeleteLocalRef(localStringArrayClass);
voidsetCenterPositionjdoublejdoublejdoubleID=NULL; 
jdoubleArraydrawTextContentID=NULL; 
voidsetFilledBoxSizejdoublejdoubleID=NULL; 
jdoubleArraygetScreenBoundingBoxjdoublejdoublejdoubleID=NULL; 
jdoubleArrayupdateParentFigurejintID=NULL; 


}

// Generic methods

void CenteredTextDrawerGL::synchronize() {
if (getCurrentEnv()->MonitorEnter(instance) != JNI_OK) {
throw GiwsException::JniMonitorException(getCurrentEnv(), "CenteredTextDrawerGL");
}
}

void CenteredTextDrawerGL::endSynchronize() {
if ( getCurrentEnv()->MonitorExit(instance) != JNI_OK) {
throw GiwsException::JniMonitorException(getCurrentEnv(), "CenteredTextDrawerGL");
}
}
// Method(s)

void CenteredTextDrawerGL::display (){

JNIEnv * curEnv = getCurrentEnv();

if (voiddisplayID==NULL) { /* Use the cache Luke */ voiddisplayID = curEnv->GetMethodID(this->instanceClass, "display", "()V" ) ;
if (voiddisplayID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "display");
}
}
                         curEnv->CallVoidMethod( this->instance, voiddisplayID );if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void CenteredTextDrawerGL::initializeDrawing (int figureIndex){

JNIEnv * curEnv = getCurrentEnv();

if (voidinitializeDrawingjintID==NULL) { /* Use the cache Luke */ voidinitializeDrawingjintID = curEnv->GetMethodID(this->instanceClass, "initializeDrawing", "(I)V" ) ;
if (voidinitializeDrawingjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "initializeDrawing");
}
}
                         curEnv->CallVoidMethod( this->instance, voidinitializeDrawingjintID ,figureIndex);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void CenteredTextDrawerGL::endDrawing (){

JNIEnv * curEnv = getCurrentEnv();

if (voidendDrawingID==NULL) { /* Use the cache Luke */ voidendDrawingID = curEnv->GetMethodID(this->instanceClass, "endDrawing", "()V" ) ;
if (voidendDrawingID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "endDrawing");
}
}
                         curEnv->CallVoidMethod( this->instance, voidendDrawingID );if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void CenteredTextDrawerGL::show (int figureIndex){

JNIEnv * curEnv = getCurrentEnv();

if (voidshowjintID==NULL) { /* Use the cache Luke */ voidshowjintID = curEnv->GetMethodID(this->instanceClass, "show", "(I)V" ) ;
if (voidshowjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "show");
}
}
                         curEnv->CallVoidMethod( this->instance, voidshowjintID ,figureIndex);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void CenteredTextDrawerGL::destroy (int parentFigureIndex){

JNIEnv * curEnv = getCurrentEnv();

if (voiddestroyjintID==NULL) { /* Use the cache Luke */ voiddestroyjintID = curEnv->GetMethodID(this->instanceClass, "destroy", "(I)V" ) ;
if (voiddestroyjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "destroy");
}
}
                         curEnv->CallVoidMethod( this->instance, voiddestroyjintID ,parentFigureIndex);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void CenteredTextDrawerGL::setTextParameters (int textAlignment, int color, int fontStyle, double fontSize, double rotationAngle, bool useFractionalMetrics){

JNIEnv * curEnv = getCurrentEnv();

if (voidsetTextParametersjintjintjintjdoublejdoublejbooleanID==NULL) { /* Use the cache Luke */ voidsetTextParametersjintjintjintjdoublejdoublejbooleanID = curEnv->GetMethodID(this->instanceClass, "setTextParameters", "(IIIDDZ)V" ) ;
if (voidsetTextParametersjintjintjintjdoublejdoublejbooleanID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "setTextParameters");
}
}
jboolean useFractionalMetrics_ = (static_cast<bool>(useFractionalMetrics) ? JNI_TRUE : JNI_FALSE);

                         curEnv->CallVoidMethod( this->instance, voidsetTextParametersjintjintjintjdoublejdoublejbooleanID ,textAlignment, color, fontStyle, fontSize, rotationAngle, useFractionalMetrics_);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void CenteredTextDrawerGL::setBoxDrawingParameters (bool drawBoxLine, bool drawBoxBackground, int lineColor, int backgroundColor){

JNIEnv * curEnv = getCurrentEnv();

if (voidsetBoxDrawingParametersjbooleanjbooleanjintjintID==NULL) { /* Use the cache Luke */ voidsetBoxDrawingParametersjbooleanjbooleanjintjintID = curEnv->GetMethodID(this->instanceClass, "setBoxDrawingParameters", "(ZZII)V" ) ;
if (voidsetBoxDrawingParametersjbooleanjbooleanjintjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "setBoxDrawingParameters");
}
}
jboolean drawBoxLine_ = (static_cast<bool>(drawBoxLine) ? JNI_TRUE : JNI_FALSE);

jboolean drawBoxBackground_ = (static_cast<bool>(drawBoxBackground) ? JNI_TRUE : JNI_FALSE);

                         curEnv->CallVoidMethod( this->instance, voidsetBoxDrawingParametersjbooleanjbooleanjintjintID ,drawBoxLine_, drawBoxBackground_, lineColor, backgroundColor);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void CenteredTextDrawerGL::setTextContent (char ** text, int textSize, int nbRow, int nbCol){

JNIEnv * curEnv = getCurrentEnv();

if (voidsetTextContentjobjectArrayjintjintID==NULL) { /* Use the cache Luke */ voidsetTextContentjobjectArrayjintjintID = curEnv->GetMethodID(this->instanceClass, "setTextContent", "([Ljava/lang/String;II)V" ) ;
if (voidsetTextContentjobjectArrayjintjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "setTextContent");
}
}jclass stringArrayClass = curEnv->FindClass("java/lang/String");

// create java array of strings.
jobjectArray text_ = curEnv->NewObjectArray( textSize, stringArrayClass, NULL);
if (text_ == NULL)
{
throw GiwsException::JniBadAllocException(curEnv);
}

// convert each char * to java strings and fill the java array.
for ( int i = 0; i < textSize; i++)
{
jstring TempString = curEnv->NewStringUTF( text[i] );
if (TempString == NULL)
{
throw GiwsException::JniBadAllocException(curEnv);
}

curEnv->SetObjectArrayElement( text_, i, TempString);

// avoid keeping reference on to many strings
curEnv->DeleteLocalRef(TempString);
}
                         curEnv->CallVoidMethod( this->instance, voidsetTextContentjobjectArrayjintjintID ,text_, nbRow, nbCol);curEnv->DeleteLocalRef(stringArrayClass);
curEnv->DeleteLocalRef(text_);
if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void CenteredTextDrawerGL::setCenterPosition (double centerX, double centerY, double centerZ){

JNIEnv * curEnv = getCurrentEnv();

if (voidsetCenterPositionjdoublejdoublejdoubleID==NULL) { /* Use the cache Luke */ voidsetCenterPositionjdoublejdoublejdoubleID = curEnv->GetMethodID(this->instanceClass, "setCenterPosition", "(DDD)V" ) ;
if (voidsetCenterPositionjdoublejdoublejdoubleID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "setCenterPosition");
}
}
                         curEnv->CallVoidMethod( this->instance, voidsetCenterPositionjdoublejdoublejdoubleID ,centerX, centerY, centerZ);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

double * CenteredTextDrawerGL::drawTextContent (){

JNIEnv * curEnv = getCurrentEnv();

if (jdoubleArraydrawTextContentID==NULL) { /* Use the cache Luke */ jdoubleArraydrawTextContentID = curEnv->GetMethodID(this->instanceClass, "drawTextContent", "()[D" ) ;
if (jdoubleArraydrawTextContentID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "drawTextContent");
}
}
                        jdoubleArray res =  static_cast<jdoubleArray>( curEnv->CallObjectMethod( this->instance, jdoubleArraydrawTextContentID ));if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
jsize len = curEnv->GetArrayLength(res);
jboolean isCopy = JNI_FALSE;

/* faster than getXXXArrayElements */
jdouble *resultsArray = static_cast<jdouble *>(curEnv->GetPrimitiveArrayCritical(res, &isCopy));
double * myArray= new double[len];

for (jsize i = 0; i < len; i++){
myArray[i]=resultsArray[i];
}
curEnv->ReleasePrimitiveArrayCritical(res, resultsArray, JNI_ABORT);

                        curEnv->DeleteLocalRef(res);
if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
return myArray;

}

void CenteredTextDrawerGL::setFilledBoxSize (double boxWidth, double boxHeight){

JNIEnv * curEnv = getCurrentEnv();

if (voidsetFilledBoxSizejdoublejdoubleID==NULL) { /* Use the cache Luke */ voidsetFilledBoxSizejdoublejdoubleID = curEnv->GetMethodID(this->instanceClass, "setFilledBoxSize", "(DD)V" ) ;
if (voidsetFilledBoxSizejdoublejdoubleID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "setFilledBoxSize");
}
}
                         curEnv->CallVoidMethod( this->instance, voidsetFilledBoxSizejdoublejdoubleID ,boxWidth, boxHeight);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

double * CenteredTextDrawerGL::getScreenBoundingBox (double centerPixX, double centerPixY, double centerPixZ){

JNIEnv * curEnv = getCurrentEnv();

if (jdoubleArraygetScreenBoundingBoxjdoublejdoublejdoubleID==NULL) { /* Use the cache Luke */ jdoubleArraygetScreenBoundingBoxjdoublejdoublejdoubleID = curEnv->GetMethodID(this->instanceClass, "getScreenBoundingBox", "(DDD)[D" ) ;
if (jdoubleArraygetScreenBoundingBoxjdoublejdoublejdoubleID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "getScreenBoundingBox");
}
}
                        jdoubleArray res =  static_cast<jdoubleArray>( curEnv->CallObjectMethod( this->instance, jdoubleArraygetScreenBoundingBoxjdoublejdoublejdoubleID ,centerPixX, centerPixY, centerPixZ));if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
jsize len = curEnv->GetArrayLength(res);
jboolean isCopy = JNI_FALSE;

/* faster than getXXXArrayElements */
jdouble *resultsArray = static_cast<jdouble *>(curEnv->GetPrimitiveArrayCritical(res, &isCopy));
double * myArray= new double[len];

for (jsize i = 0; i < len; i++){
myArray[i]=resultsArray[i];
}
curEnv->ReleasePrimitiveArrayCritical(res, resultsArray, JNI_ABORT);

                        curEnv->DeleteLocalRef(res);
if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
return myArray;

}

double * CenteredTextDrawerGL::updateParentFigure (int parentFigureIndex){

JNIEnv * curEnv = getCurrentEnv();

if (jdoubleArrayupdateParentFigurejintID==NULL) { /* Use the cache Luke */ jdoubleArrayupdateParentFigurejintID = curEnv->GetMethodID(this->instanceClass, "updateParentFigure", "(I)[D" ) ;
if (jdoubleArrayupdateParentFigurejintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "updateParentFigure");
}
}
                        jdoubleArray res =  static_cast<jdoubleArray>( curEnv->CallObjectMethod( this->instance, jdoubleArrayupdateParentFigurejintID ,parentFigureIndex));if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
jsize len = curEnv->GetArrayLength(res);
jboolean isCopy = JNI_FALSE;

/* faster than getXXXArrayElements */
jdouble *resultsArray = static_cast<jdouble *>(curEnv->GetPrimitiveArrayCritical(res, &isCopy));
double * myArray= new double[len];

for (jsize i = 0; i < len; i++){
myArray[i]=resultsArray[i];
}
curEnv->ReleasePrimitiveArrayCritical(res, resultsArray, JNI_ABORT);

                        curEnv->DeleteLocalRef(res);
if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
return myArray;

}

}
