#include "SurfaceFacetDrawerGL.hxx"
/* Generated by GIWS (version 1.0.5) */
/*

Copyright 2007-2008 INRIA

Author : Sylvestre Ledru & others

This software is a computer program whose purpose is to hide the complexity
of accessing Java objects/methods from C++ code.

This software is governed by the CeCILL-B license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL-B
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL-B license and that you accept its terms.
*/

namespace org_scilab_modules_renderer_surfaceDrawing {

// Returns the current env

JNIEnv * SurfaceFacetDrawerGL::getCurrentEnv() {
JNIEnv * curEnv = NULL;
this->jvm->AttachCurrentThread(reinterpret_cast<void **>(&curEnv), NULL);
return curEnv;
}
// Destructor

SurfaceFacetDrawerGL::~SurfaceFacetDrawerGL() {
JNIEnv * curEnv = NULL;
this->jvm->AttachCurrentThread(reinterpret_cast<void **>(&curEnv), NULL);

curEnv->DeleteGlobalRef(this->instance);
curEnv->DeleteGlobalRef(this->instanceClass);
}
// Constructors

SurfaceFacetDrawerGL::SurfaceFacetDrawerGL(JavaVM * jvm_) {
jmethodID constructObject = NULL ;
jobject localInstance ;
jclass localClass ;
const std::string construct="<init>";
const std::string param="()V";
jvm=jvm_;

JNIEnv * curEnv = getCurrentEnv();

localClass = curEnv->FindClass( this->className().c_str() ) ;
if (localClass == NULL) {
  throw GiwsException::JniClassNotFoundException(curEnv, this->className());
}

this->instanceClass = static_cast<jclass>(curEnv->NewGlobalRef(localClass));

/* localClass is not needed anymore */
curEnv->DeleteLocalRef(localClass);

if (this->instanceClass == NULL) {
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}


constructObject = curEnv->GetMethodID( this->instanceClass, construct.c_str() , param.c_str() ) ;
if(constructObject == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}

localInstance = curEnv->NewObject( this->instanceClass, constructObject ) ;
if(localInstance == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}
 
this->instance = curEnv->NewGlobalRef(localInstance) ;
if(this->instance == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
}
/* localInstance not needed anymore */
curEnv->DeleteLocalRef(localInstance);

                /* Methods ID set to NULL */
voiddisplayID=NULL; 
voidinitializeDrawingjintID=NULL; 
voidendDrawingID=NULL; 
voidshowjintID=NULL; 
voiddestroyjintID=NULL; 
voidsetDefaultColorsjintjintID=NULL; 
voidsetSurfaceTypejintjintID=NULL; 
voiddrawSurfacejdoubleArrayjdoubleArrayjdoubleArrayjintID=NULL; 
voidsetFacetsColorsjdoubleArrayID=NULL; 


}

SurfaceFacetDrawerGL::SurfaceFacetDrawerGL(JavaVM * jvm_, jobject JObj) {
        jvm=jvm_;

        JNIEnv * curEnv = getCurrentEnv();

jclass localClass = curEnv->GetObjectClass(JObj);
        this->instanceClass = static_cast<jclass>(curEnv->NewGlobalRef(localClass));
        curEnv->DeleteLocalRef(localClass);

        if (this->instanceClass == NULL) {
throw GiwsException::JniObjectCreationException(curEnv, this->className());
        }

        this->instance = curEnv->NewGlobalRef(JObj) ;
        if(this->instance == NULL){
throw GiwsException::JniObjectCreationException(curEnv, this->className());
        }
        /* Methods ID set to NULL */
        voiddisplayID=NULL; 
voidinitializeDrawingjintID=NULL; 
voidendDrawingID=NULL; 
voidshowjintID=NULL; 
voiddestroyjintID=NULL; 
voidsetDefaultColorsjintjintID=NULL; 
voidsetSurfaceTypejintjintID=NULL; 
voiddrawSurfacejdoubleArrayjdoubleArrayjdoubleArrayjintID=NULL; 
voidsetFacetsColorsjdoubleArrayID=NULL; 


}

// Generic methods

void SurfaceFacetDrawerGL::synchronize() {
if (getCurrentEnv()->MonitorEnter(instance) != JNI_OK) {
throw GiwsException::JniMonitorException(getCurrentEnv(), "SurfaceFacetDrawerGL");
}
}

void SurfaceFacetDrawerGL::endSynchronize() {
if ( getCurrentEnv()->MonitorExit(instance) != JNI_OK) {
throw GiwsException::JniMonitorException(getCurrentEnv(), "SurfaceFacetDrawerGL");
}
}
// Method(s)

void SurfaceFacetDrawerGL::display (){

JNIEnv * curEnv = getCurrentEnv();

if (voiddisplayID==NULL) { /* Use the cache Luke */ voiddisplayID = curEnv->GetMethodID(this->instanceClass, "display", "()V" ) ;
if (voiddisplayID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "display");
}
}
                         curEnv->CallVoidMethod( this->instance, voiddisplayID );if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void SurfaceFacetDrawerGL::initializeDrawing (int figureIndex){

JNIEnv * curEnv = getCurrentEnv();

if (voidinitializeDrawingjintID==NULL) { /* Use the cache Luke */ voidinitializeDrawingjintID = curEnv->GetMethodID(this->instanceClass, "initializeDrawing", "(I)V" ) ;
if (voidinitializeDrawingjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "initializeDrawing");
}
}
                         curEnv->CallVoidMethod( this->instance, voidinitializeDrawingjintID ,figureIndex);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void SurfaceFacetDrawerGL::endDrawing (){

JNIEnv * curEnv = getCurrentEnv();

if (voidendDrawingID==NULL) { /* Use the cache Luke */ voidendDrawingID = curEnv->GetMethodID(this->instanceClass, "endDrawing", "()V" ) ;
if (voidendDrawingID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "endDrawing");
}
}
                         curEnv->CallVoidMethod( this->instance, voidendDrawingID );if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void SurfaceFacetDrawerGL::show (int figureIndex){

JNIEnv * curEnv = getCurrentEnv();

if (voidshowjintID==NULL) { /* Use the cache Luke */ voidshowjintID = curEnv->GetMethodID(this->instanceClass, "show", "(I)V" ) ;
if (voidshowjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "show");
}
}
                         curEnv->CallVoidMethod( this->instance, voidshowjintID ,figureIndex);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void SurfaceFacetDrawerGL::destroy (int parentFigureIndex){

JNIEnv * curEnv = getCurrentEnv();

if (voiddestroyjintID==NULL) { /* Use the cache Luke */ voiddestroyjintID = curEnv->GetMethodID(this->instanceClass, "destroy", "(I)V" ) ;
if (voiddestroyjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "destroy");
}
}
                         curEnv->CallVoidMethod( this->instance, voiddestroyjintID ,parentFigureIndex);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void SurfaceFacetDrawerGL::setDefaultColors (int defaultColor, int hiddenColor){

JNIEnv * curEnv = getCurrentEnv();

if (voidsetDefaultColorsjintjintID==NULL) { /* Use the cache Luke */ voidsetDefaultColorsjintjintID = curEnv->GetMethodID(this->instanceClass, "setDefaultColors", "(II)V" ) ;
if (voidsetDefaultColorsjintjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "setDefaultColors");
}
}
                         curEnv->CallVoidMethod( this->instance, voidsetDefaultColorsjintjintID ,defaultColor, hiddenColor);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void SurfaceFacetDrawerGL::setSurfaceType (int typeOfSurface, int colorFlag){

JNIEnv * curEnv = getCurrentEnv();

if (voidsetSurfaceTypejintjintID==NULL) { /* Use the cache Luke */ voidsetSurfaceTypejintjintID = curEnv->GetMethodID(this->instanceClass, "setSurfaceType", "(II)V" ) ;
if (voidsetSurfaceTypejintjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "setSurfaceType");
}
}
                         curEnv->CallVoidMethod( this->instance, voidsetSurfaceTypejintjintID ,typeOfSurface, colorFlag);if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void SurfaceFacetDrawerGL::drawSurface (double * xCoords, int xCoordsSize, double * yCoords, int yCoordsSize, double * zCoords, int zCoordsSize, int nbFacets){

JNIEnv * curEnv = getCurrentEnv();

if (voiddrawSurfacejdoubleArrayjdoubleArrayjdoubleArrayjintID==NULL) { /* Use the cache Luke */ voiddrawSurfacejdoubleArrayjdoubleArrayjdoubleArrayjintID = curEnv->GetMethodID(this->instanceClass, "drawSurface", "([D[D[DI)V" ) ;
if (voiddrawSurfacejdoubleArrayjdoubleArrayjdoubleArrayjintID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "drawSurface");
}
}
jdoubleArray xCoords_ = curEnv->NewDoubleArray( xCoordsSize ) ;

if (xCoords_ == NULL)
{
// check that allocation succeed
throw GiwsException::JniBadAllocException(curEnv);
}

curEnv->SetDoubleArrayRegion( xCoords_, 0, xCoordsSize, (jdouble*)(xCoords) ) ;


jdoubleArray yCoords_ = curEnv->NewDoubleArray( yCoordsSize ) ;

if (yCoords_ == NULL)
{
// check that allocation succeed
throw GiwsException::JniBadAllocException(curEnv);
}

curEnv->SetDoubleArrayRegion( yCoords_, 0, yCoordsSize, (jdouble*)(yCoords) ) ;


jdoubleArray zCoords_ = curEnv->NewDoubleArray( zCoordsSize ) ;

if (zCoords_ == NULL)
{
// check that allocation succeed
throw GiwsException::JniBadAllocException(curEnv);
}

curEnv->SetDoubleArrayRegion( zCoords_, 0, zCoordsSize, (jdouble*)(zCoords) ) ;


                         curEnv->CallVoidMethod( this->instance, voiddrawSurfacejdoubleArrayjdoubleArrayjdoubleArrayjintID ,xCoords_, yCoords_, zCoords_, nbFacets);curEnv->DeleteLocalRef(xCoords_);
curEnv->DeleteLocalRef(yCoords_);
curEnv->DeleteLocalRef(zCoords_);
if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

void SurfaceFacetDrawerGL::setFacetsColors (double * colors, int colorsSize){

JNIEnv * curEnv = getCurrentEnv();

if (voidsetFacetsColorsjdoubleArrayID==NULL) { /* Use the cache Luke */ voidsetFacetsColorsjdoubleArrayID = curEnv->GetMethodID(this->instanceClass, "setFacetsColors", "([D)V" ) ;
if (voidsetFacetsColorsjdoubleArrayID == NULL) {
throw GiwsException::JniMethodNotFoundException(curEnv, "setFacetsColors");
}
}
jdoubleArray colors_ = curEnv->NewDoubleArray( colorsSize ) ;

if (colors_ == NULL)
{
// check that allocation succeed
throw GiwsException::JniBadAllocException(curEnv);
}

curEnv->SetDoubleArrayRegion( colors_, 0, colorsSize, (jdouble*)(colors) ) ;


                         curEnv->CallVoidMethod( this->instance, voidsetFacetsColorsjdoubleArrayID ,colors_);curEnv->DeleteLocalRef(colors_);
if (curEnv->ExceptionCheck()) {
throw GiwsException::JniCallMethodException(curEnv);
}
}

}
